<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirItineraryTypeOriginDestinationOption ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfAirItineraryTypeOriginDestinationOption extends AbstractStructArrayBase
{
    /**
     * The OriginDestinationOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgOriginDestinationOption[]
     */
    public $OriginDestinationOption;
    /**
     * Constructor method for ArrayOfAirItineraryTypeOriginDestinationOption
     * @uses DgArrayOfAirItineraryTypeOriginDestinationOption::setOriginDestinationOption()
     * @param \dgsoft\StructType\DgOriginDestinationOption[] $originDestinationOption
     */
    public function __construct(array $originDestinationOption = array())
    {
        $this
            ->setOriginDestinationOption($originDestinationOption);
    }
    /**
     * Get OriginDestinationOption value
     * @return \dgsoft\StructType\DgOriginDestinationOption[]|null
     */
    public function getOriginDestinationOption()
    {
        return $this->OriginDestinationOption;
    }
    /**
     * Set OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOriginDestinationOption[] $originDestinationOption
     * @return \dgsoft\ArrayType\DgArrayOfAirItineraryTypeOriginDestinationOption
     */
    public function setOriginDestinationOption(array $originDestinationOption = array())
    {
        foreach ($originDestinationOption as $arrayOfAirItineraryTypeOriginDestinationOptionOriginDestinationOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirItineraryTypeOriginDestinationOptionOriginDestinationOptionItem instanceof \dgsoft\StructType\DgOriginDestinationOption) {
                throw new \InvalidArgumentException(sprintf('The OriginDestinationOption property can only contain items of \dgsoft\StructType\DgOriginDestinationOption, "%s" given', is_object($arrayOfAirItineraryTypeOriginDestinationOptionOriginDestinationOptionItem) ? get_class($arrayOfAirItineraryTypeOriginDestinationOptionOriginDestinationOptionItem) : gettype($arrayOfAirItineraryTypeOriginDestinationOptionOriginDestinationOptionItem)), __LINE__);
            }
        }
        $this->OriginDestinationOption = $originDestinationOption;
        return $this;
    }
    /**
     * Add item to OriginDestinationOption value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgOriginDestinationOption $item
     * @return \dgsoft\ArrayType\DgArrayOfAirItineraryTypeOriginDestinationOption
     */
    public function addToOriginDestinationOption(\dgsoft\StructType\DgOriginDestinationOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgOriginDestinationOption) {
            throw new \InvalidArgumentException(sprintf('The OriginDestinationOption property can only contain items of \dgsoft\StructType\DgOriginDestinationOption, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OriginDestinationOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgOriginDestinationOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgOriginDestinationOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgOriginDestinationOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgOriginDestinationOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgOriginDestinationOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OriginDestinationOption
     */
    public function getAttributeName()
    {
        return 'OriginDestinationOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfAirItineraryTypeOriginDestinationOption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
